require 'gyoku'
require 'base64'

module EgonGate
  module Kobra
    class Message

      def initialize(egsb_message, mode='sync')
        @egsb_message = egsb_message
        @mode = mode
      end

      def config
        {
          is_id: 124
        }
      end

      def body
        Base64.encode64 @egsb_message.to_s
      end

      def message_details
        {class: @egsb_message.message_code, attributes!: {class: {mode: @mode}}}
      end

      def message_hash
        { gate_message: {
            version: '2.0',
            header: {
              message_details: message_details,
              sender_details: {authentication: {'ISId' => config[:is_id]}, attributes!: { authentication: {type: 'clear'} }},
              attributes!: {message_details: {type: 'request'}}
            },
            body: body
          }
        }
      end

      def to_s
        Gyoku.xml(message_hash, key_converter: :camelcase)
      end
    end
  end
end
