require 'egon_gate/kobra/message'
require 'egon_gate/kobra/response'

module EgonGate
  module Kobra
    class Request

      def client
        @client ||= Savon.client(wsdl: 'https://serviszr01.servis.justice.cz/GateService/GateService.svc?wsdl', convert_request_keys_to: :camelcase,
          ssl_verify_mode: :none, log: true, pretty_print_xml: true)
      end

      def send_message(egsb_message)
        message = Message.new(egsb_message)
        res = client.call(:get_data, message: { 'inputXml' => message.to_s }, attributes: {'xmlns' => 'http://tempuri.org/'})
        EgonGate::Kobra::Response.new(res)
      end

    end
  end
end
