require "nori"

module EgonGate
  module Kobra
    class Response

      def initialize(soap_response)
        @soap_response = soap_response
        @egsb_string = soap_response.body[:get_data_response][:get_data_result]
      end

      def pure_xml
        @responsed_body ||= nori.parse(@egsb_string)
      end

      def egsb_response
        @response ||= nori.parse( Base64.decode64 pure_xml[:gate_message][:body] )
      end

      def error?
        egsb_response.values.first[:odpoved_info][:status][:vysledek_kod] != "OK"
      end

      def error_message
        egsb_response.values.first[:odpoved_info][:status][:vysledek_detail][:vysledek_sub_kod]
      end

      private

      def nori
        @soap_response.__send__(:nori)
      end

    end
  end
end
